Subject: bug#53126: 29.0.50; [PATCH] Lazy highlight/count when reading query-replace string, etc.

From: Augusto Stoffel <[email-masked]>
Date: Wed, 16 Mar 2022 21:25:01 +0100

On Wed, 16 Mar 2022 at 21:02, Juri Linkov <[email-masked]> wrote:

>>>> @@ -2350,7 +2352,9 @@ isearch-query-replace
>>>> +    (let ((lazy-highlight-cleanup (and lazy-highlight-cleanup
>>>> +                                       (not query-replace-lazy-highlight))))
>>>> +      (isearch-done nil t))
>>>
>>> Is this some optimization?  It seems it's intended to leave
>>> some existing highlighting?  Is this to avoid double highlighting?
>>
>> The weird let-binding for lazy-highlight-cleanup is indeed an
>> optimization.  Without it, you can see the lazy highlights briefly flash
>> off an on again after you hit RET to confirm the replacement string.
>>
>> (Same remark explains why condition-case is used instead of a
>> unwind-protect in query-replace-read-args).
>
> When I tried your latest patch, it still flashes when it starts
> the perform-replace loop.

Does it always happen for you?  I see this occasionally, and as far as I
can tell it's random.

>>> The problem is that when these conditions 'isearch-mode (null isearch-message-function)'
>>> are removed, now this shows wrong counts in the minibuffer history search
>>> (e.g. 'M-! C-r s C-r C-r ...') and the shell history search
>>> (e.g. 'M-x shell RET M-r s C-r C-r ...').  Before this change
>>> counting was disabled in the history search because it shows wrong numbers.
>>
>> Okay, so this means we should bind isearch-lazy-count to nil in these
>> commands, do you agree?  It has always looked like a hack to me to check
>> for (null isearch-message-function).
>
> Binding isearch-lazy-count to nil could serve as a temporary measure
> until lazy-count will be supported in the history search.

Okay, the patch from yesterday already does that.

>>> For some reasons the package lisp/mb-depth.el uses 'after-string'
>>> instead of 'before-string', and (make-overlay (point-min) (1+ (point-min)))
>>> instead of (make-overlay (point-min) (point-min)),
>>> so maybe better to do the same?
>>
>> Okay, but do you know the reasons?  I've changed to before-string, but I
>> don't like to make the overlay 1 char longer than it has to be :-P
>
> I don't know the reason.  Since it works in your patch, then it's ok.

Great.

>>> Highlighting is still incorrect for word replacement ('C-u M-%')
>>> and for non-nil 'replace-char-fold'.  To handle these cases correctly,
>>> 'replace-highlight' uses:
>>>
>>> 	    (isearch-regexp-function (or replace-regexp-function
>>> 					 delimited-flag
>>> 					 (and replace-char-fold
>>> 					      (not regexp-flag)
>>> 					      #'char-fold-to-regexp)))
>>
>> Okay, fixed this.  (BTW, where is replace-regexp-function used?  It's
>> not set anywhere in Emacs, and it's not a defcustom either.)
>
> 'replace-regexp-function' was added recently in bug#52558
> to allow implementing more regexp types in bug#54017.

Ah, I see.  I must say, in isearch.el I don't like this trichotomy of
the regexp/literal/with isearch-regexp-function cases.  Ideally, the
regexp and literal search cases would be handled by
isearch-regexp-function set to identity respectively regexp-quote.  But
it would be a large refactoring, perhaps with only aesthetic benefits.